/**
 * @function captchaSVG
 */
'use strict'

const React = require('react')
const xmljson = require('xmljson')
const co = require('co')
const ReactDOMServer = require('react-dom/server')
const { ApCaptchaSvg } = require('apeman-react-captcha')

/** @lends captchaSVG */
function captchaSVG (text, options = {}) {
  let elm = React.createElement(ApCaptchaSvg, {
    text
  })
  let src = ReactDOMServer.renderToStaticMarkup(elm)
  return co(function * () {
    let data = yield new Promise((resolve, reject) =>
      xmljson.to_json(src, (err, data) => err ? reject(err) : resolve(data))
    )
    data.svg.$.xmlns = "http://www.w3.org/2000/svg"
    let result = yield new Promise((resolve, reject) =>
      xmljson.to_xml(JSON.stringify(data), (err, xml) => err ? reject(err) : resolve(xml))
    )
    return result && result.replace(/^<data>/, '').replace(/<\/data>$/, '')
  })
}

module.exports = captchaSVG;
