/**
 * Test case for define.
 * Runs with mocha.
 */
'use strict'

const define = require('../lib/define.js')
const assert = require('assert')
const co = require('co')
const fs = require('fs')

describe('define', () => {
  function noop () {
  }

  before(() => co(function * () {
  }))

  after(() => co(function * () {
  }))

  it('Define', () => co(function * () {
    let filename = `${__dirname}/../tmp/foo/captcha.json`
    let task = define(filename, {
      imageDir: `${__dirname}/../tmp/foo/public/captcha`,
      count: 3,
      clean: true
    })
    assert.ok(task)
    let context = {
      verbose: false,
      logger: {
        info: noop,
        debug: noop,
        trace: noop
      }
    }
    yield task(context)

    assert.ok(
      fs.existsSync(filename)
    )

    let data = require(filename)
    Object.keys(data).forEach((name) => {
      assert.ok(
        fs.existsSync(name),
        `${name} should exists.`
      )
    })
  }))

})

/* global describe, before, after, it */
